package com.sun.java.swing.plaf.motif;

import java.awt.event.MouseEvent;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.awt.Insets;
import java.awt.FontMetrics;
import sun.swing.SwingUtilities2;
import javax.swing.UIManager;
import javax.swing.JPopupMenu;
import java.awt.Dimension;
import javax.swing.plaf.ComponentUI;
import javax.swing.JComponent;
import java.awt.Font;
import javax.swing.border.Border;
import javax.swing.plaf.basic.BasicPopupMenuUI;

public class MotifPopupMenuUI extends BasicPopupMenuUI
{
    private static Border border;
    private Font titleFont;
    
    public MotifPopupMenuUI() {
        this.titleFont = null;
    }
    
    public static ComponentUI createUI(JComponent component) {
        return new MotifPopupMenuUI();
    }
    
    @Override
    public Dimension getPreferredSize(JComponent c) {
        Dimension preferredLayoutSize = c.getLayout().preferredLayoutSize(c);
        String label = ((JPopupMenu)c).getLabel();
        if (this.titleFont == null) {
            this.titleFont = UIManager.getLookAndFeelDefaults().getFont("PopupMenu.font");
        }
        FontMetrics fontMetrics = c.getFontMetrics(this.titleFont);
        int n = 0;
        if (label != null) {
            n += SwingUtilities2.stringWidth(c, fontMetrics, label);
        }
        if (preferredLayoutSize.width < n) {
            preferredLayoutSize.width = n + 8;
            Insets insets = c.getInsets();
            if (insets != null) {
                preferredLayoutSize.width += insets.left + insets.right;
            }
            if (MotifPopupMenuUI.border != null) {
                Insets borderInsets = MotifPopupMenuUI.border.getBorderInsets(c);
                preferredLayoutSize.width += borderInsets.left + borderInsets.right;
                return preferredLayoutSize;
            }
            return preferredLayoutSize;
        }
        else {
            return null;
        }
    }
    
    protected ChangeListener createChangeListener(JPopupMenu popupMenu) {
        return new ChangeListener() {
            @Override
            public void stateChanged(ChangeEvent changeEvent) {
            }
        };
    }
    
    @Override
    public boolean isPopupTrigger(MouseEvent mouseEvent) {
        return mouseEvent.getID() == 501 && (mouseEvent.getModifiers() & 0x4) != 0x0;
    }
    
    static {
        MotifPopupMenuUI.border = null;
    }
}
